package com.bipt.intelligentapplicationorchestrationservice.controller;

import com.bipt.intelligentapplicationorchestrationservice.pojo.*;
import com.bipt.intelligentapplicationorchestrationservice.service.PublishService;
import com.bipt.intelligentapplicationorchestrationservice.util.NacosServiceUtil;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@Tag(name ="服务发布相关接口")
@RestController
@RequestMapping("/publish")
@Slf4j
public class publishController {
    @Autowired
    private PublishService publishService;

    @Autowired
    private RedisTemplate redisTemplate;
    @Autowired
    private NacosServiceUtil nacosServiceUtil;

    @PostMapping
    @Operation(summary ="新增发布请求")
    @Transactional
    public OptResult<List<ServicePublishVO>> save(@RequestBody ServicePublishDTO servicePublishDTO) {
        log.info("模型发布请求:{}", servicePublishDTO);
        publishService.save(servicePublishDTO);
        Long modelId = servicePublishDTO.getModelId();
        String key = "Model_" + modelId;




        try {
            nacosServiceUtil.registerService(
                servicePublishDTO.getModelId().toString(),
                servicePublishDTO.getIp(),
                8080
            );
            log.info("Nacos服务注册成功");
        } catch (Exception e) {
            log.error("Nacos服务注册失败", e);
        }

        return OptResult.success();
    }







}
