package com.bipt.intelligentapplicationorchestrationservice.util;

import com.alibaba.nacos.api.naming.NamingFactory;
import com.alibaba.nacos.api.naming.NamingService;
import com.alibaba.nacos.api.naming.pojo.Instance;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class NacosServiceUtil {
    @Value("${spring.cloud.nacos.discovery.server-addr}")
    private String nacosServerAddr;

    public void registerService(String serviceName, String ip, int port) throws Exception {
        NamingService naming = NamingFactory.createNamingService(nacosServerAddr);
        Instance instance = new Instance();
        instance.setIp(ip);
        instance.setPort(port);
        naming.registerInstance(serviceName, instance);
    }
}